/**
 * String工具类
 */
const StringUtils = {};

// 按照特定字符分割成数组
StringUtils.toArray = function (string, char) {
  char = char || ',';
  return string.split(char);
};

// 获取字符数组
StringUtils.toCharArray = function (string) {
  return string.split("");
};

// 获取N个相同的字符串
StringUtils.repeat = function (string, num) {
  var tmpArr = [];
  for (var i = 0; i < num; i++)
    tmpArr.push(string);
  return tmpArr.join("");
};

// 逆序
StringUtils.reverse = function (string) {
  return string.split("").reverse().join("");
};

// 测试是否是数字
StringUtils.isNumeric = function (string) {
  var tmpFloat = parseFloat(string);
  if (isNaN(tmpFloat))
    return false;
  var tmpLen = string.length - tmpFloat.toString().length;
  return tmpFloat + "0".Repeat(tmpLen) == string;
};

//测试是否是整数
StringUtils.isInt = function (string) {
  if (string == "NaN")
    return false;
  return string == parseInt(string).toString();
};

// 合并多个空白为一个空白
StringUtils.resetBlank = function (string) {
  return string.replace(/s+/g, " ");
};

// 除去左边空白
StringUtils.LTrim = function (string) {
  return string.replace(/^s+/g, "");
};

// 除去右边空白
StringUtils.RTrim = function (string) {
  return string.replace(/s+$/g, "");
};

// 除去两边空白
StringUtils.trim = function (string) {
  return string.replace(/(^s+)|(s+$)/g, "");
};

// 保留数字
StringUtils.getNum = function (string) {
  return string.replace(/[^d]/g, "");
};

// 保留字母
StringUtils.getEn = function (string) {
  return string.replace(/[^A-Za-z]/g, "");
}
// 保留中文
StringUtils.getCn = function (string) {
  return string.replace(/[^u4e00-u9fa5uf900-ufa2d]/g, "");
};

// 得到字节长度
StringUtils.getRealLength = function (string) {
  return string.replace(/[^x00-xff]/g, "--").length;
};

// 从左截取指定长度的字串
StringUtils.left = function (string, n) {
  return string.slice(0, n);
};

// 从右截取指定长度的字串
StringUtils.right = function (string, n) {
  return string.slice(string.length - n);
};

// HTML编码
StringUtils.HTMLEncode = function (string) {
  var re = string;
  var q1 = [/x26/g, /x3C/g, /x3E/g, /x20/g];
  var q2 = ["&", "<", ">", " "];
  for (var i = 0; i < q1.length; i++)
    re = re.replace(q1[i], q2[i]);
  return re;
};

// Unicode转化
StringUtils.ascW = function (string) {
  var strText = "";
  for (var i = 0; i < string.length; i++)
    strText += "&#" + string.charCodeAt(i) + ";";
  return strText;
};
